#include "descriptor/descriptor.h"

// Per compilare (make clean, xmkmf, make) poi lanciare da xcrayt  il file .md

int main(void) {

	char * tex_stanza = "mattoni.hr";
	char * tex_pavimento = "mattoni2.hr";
	char * tex_tavolo1 = "marmonero.hr";
	char * tex_granito = "granito.hr";
	char * tex_scacchiera1 = "Ambrosia.hr";
	char * tex_scacchiera2 = "scacchiera.hr";
	char * tex_scacchi = "bumpLegno.hr";
	char * tex_scudo = "scudo.hr";
	char * tex_sedia = "Legnoscuro.hr";
	char * tex_steel = "brushsteel.hr";
	char * tex_legnochiaro= "Legnochiaro.hr";
	char * tex_tappeto ="tappeto.hr";

	char * tex_bump ="Hairbmp2.hr";
	char * text_bump_muro = "bump10.hr";

	ITEM	metal, material1, glass, cera, white,black, fire;
	ITEM	scene;
	ITEM	tavolo, sedia1, sedia2, colonna, scudo1, scudo2, calice1, calice2, tappeto;
	ITEM	parete1,parete2, parete3,parete4,parete5;
	ITEM	pianotavolo, gambatavolo;
	ITEM	pianoscacchiera, bordoscacchiera;
	ITEM	lama, pomo, guardia, impugnatura;
	ITEM	candela, supcandela, fiamma;
	ITEM	PezziB, alfiereb, cavallob, torreb, pedoneb1, pedoneb2,pedoneb3, pedoneb4, pedoneb5,  pedoneb6, pedoneb7 ;
	ITEM	PezziN, alfieren, cavallon, torren, pedonen1, pedonen2,pedonen3, pedonen4, pedonen5, pedonen6, pedonen7 ;
	ITEM	testa_cavallo,piedistallo;

	set_background(0.676,0.861,0.953,TRUE);
	set_ambient_light(1,1,1,0.7);
	
	/*** ATTRIBUTE material1 ***/
	material1 = create_attribute("material1");
		set_color(material1,0.58,0.56,0.5,0.5,0.5);
		set_reflectivity(material1,0,2);
	
	/*** ATTRIBUTE cera ***/
	cera = create_attribute("cera");
		set_color(cera,1,1,1,0.2,0.8);
		set_reflectivity(cera,0,1);

	metal = create_attribute("metal");
		set_color(metal,0.7,0.7,0,0.2,0.8);
		set_reflectivity(metal,0.6,3);

	fire = create_attribute("fire");
		set_color(fire,1,1,0,0.2,0.8);
		set_reflectivity(fire,0,2);

	/*** ATTRIBUTE white ***/
	white = create_attribute("white");
		set_color(white,1,1,1,0.2,0.8);
		set_reflectivity(white,0.1,10);
	
	/*** ATTRIBUTE black ***/
	black = create_attribute("black");
		set_color(black,0.1,0.1,0.1,0.5,0.5);
		set_reflectivity(black,0.1,10);

	/*** ATTRIBUTE glass ***/
	glass = create_attribute("glass");
		set_color(glass,0.68,0.86,1,0.5,0.5);
		set_reflectivity(glass,0.4,3);
		set_transparency(glass,0.9,0.68,1,1.2);


	create_warn_light(-102.895,-80.773,112.766, 0.501,0.473,-0.724, 0.9,0.9,0.61, 0.8,0, 5,30, 0,0,0,0,0,"light1");
	create_warn_light(-23.949,199.636,15.014, -0.102,-0.994,0.015,0.9,0.9,0.61, 0.8,0, 5,30, 0,0,0,0,0,"light2");
	create_warn_light(-20,45,11, 0.8,0.5,-0.3, 0.75,0.7,0.35, 5,45, 1,180, 0,0,0,0,0,"candela");
	// creazione degli oggetti
	
	parete1 = read_nurbs("parete1.db");	
	set_projection_texture(parete1,material1,tex_stanza,1,1,0.3,0.5);
//  	set_bump_texture(parete1, material1, text_bump_muro, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(parete1,120,150,80);
	set_z_rotate(parete1,45,1);
	set_translate(parete1,-15,3,-25);

	parete2 = read_nurbs("parete2.db");
	set_projection_texture(parete2,material1,tex_stanza,2,1,0.4,0.5);
// 	set_bump_texture(parete2, material1, text_bump_muro, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(parete2,120,150,80);
	set_z_rotate(parete2,45,1);
	set_translate(parete2,-15,3,-25);

	parete3 = read_nurbs("parete3.db");
	set_projection_texture(parete3,material1,tex_pavimento,2,1,0.4,0.5);
// 	set_bump_texture(parete3, material1, text_bump_muro, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(parete3,120,150,80);
	set_z_rotate(parete3,45,1);
	set_translate(parete3,-15,3,-25);

	parete4 = read_nurbs("parete4.db");
	set_projection_texture(parete4,material1,tex_stanza,1,1,0.4,0.5);
// 	set_bump_texture(parete4, material1, text_bump_muro, 0, 0.09,0, 0.09, 1,0.6, 0.8);

	set_scale(parete4,120,150,80);
	set_z_rotate(parete4,45,1);
	set_translate(parete4,-15,3,-25);

	parete5 = read_nurbs("parete5.db");
	set_projection_texture(parete5,material1,tex_stanza,0,1,0.4,0.5);
// 	set_bump_texture(parete5, material1, text_bump_muro,0, 0.09,0, 0.09, 1,0.6, 0.8);

	set_scale(parete5,120,150,80);
	set_z_rotate(parete5,45,1);
	set_translate(parete5,-15,3,-25);


	tappeto = read_nurbs("tappeto.db");
	set_scale(tappeto,0.9,0.9,0.9);
	set_projection_texture(tappeto,material1,tex_tappeto,2,2,0.4,0.5);
	set_translate(tappeto,-0.5,0.3,-0.415);
	set_scale(tappeto,60,60,60);

	pianotavolo = read_nurbs("pianotavolo.db");
	set_projection_texture(pianotavolo,material1,tex_tavolo1,2,1,0.4,0.5);
	set_translate(pianotavolo,-15,20,-4.3);
	set_scale(pianotavolo,1.5,1.5,1.5);
	set_attribute(pianotavolo,glass);
	
	gambatavolo = read_nurbs("gambatavolo.db");
	set_projection_texture(gambatavolo,material1,tex_granito,1,1,0.4,0.5);
	set_translate(gambatavolo,-15,20,-4.5);
	set_scale(gambatavolo,1.5,1.5,1.5);


	sedia1 = read_obj("sedia.obj","sedia1_legno");
	set_projection_texture(sedia1,material1,tex_sedia,2,1,0.4,0.5);
	set_scale(sedia1,20,20,20);
	set_translate(sedia1,-2,-4,-6);	
	set_z_rotate(sedia1,90,0);

	sedia2 = create_copy(sedia1,"sedia2_legno");
	set_z_rotate(sedia2,180,0);
	set_translate(sedia2,-55,25,0);

	colonna = read_nurbs("colonna.db");
	set_projection_texture(colonna,material1,tex_pavimento,1,1,0.4,0.5);
	set_scale(colonna,50,50,42);
	set_translate(colonna,0,-100,53);


	pianoscacchiera = read_nurbs("pianoscacc.db");
	set_projection_texture(pianoscacchiera,material1,tex_scacchiera2,2,1,0.4,0.5);
	set_scale(pianoscacchiera,8,8,8);
	set_translate(pianoscacchiera,-20,30,-5.4);


	bordoscacchiera = read_nurbs("bordoscacc.db");
	set_projection_texture(bordoscacchiera,material1,tex_scacchiera1,2,1,0.4,0.5);
	set_scale(bordoscacchiera,8,8,8);
	set_translate(bordoscacchiera,-20,30,-5.4);

	fiamma = read_nurbs("fiamma.db");
	set_scale(fiamma,7,7,7);
	set_translate(fiamma,-20,45,-2.4);
	set_attribute(fiamma,metal);	

	candela = read_nurbs("candela.db");
	set_scale(candela,7,7,7);
	set_translate(candela,-20,45,-2.4);
	set_attribute(candela,cera);

	supcandela = read_nurbs("supcandela.db");
	set_projection_texture(supcandela, material1,tex_legnochiaro,2,1,0.4,0.5);
	set_scale(supcandela,7,7,7);
	set_translate(supcandela,-20,45,-2.4);

	PezziB = read_obj("5Pezzi.obj","Pezzi_Bianchi");
	set_projection_texture(PezziB, white, tex_scacchi, 2,1,0.4,0.5);
	set_bump_texture(PezziB, white, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	PezziN = create_copy(PezziB,"Pezzi_Neri");
	set_projection_texture(PezziN, black, tex_scacchi, 2,1,0.4,0.5);
	//set_bump_texture(PezziN, black, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(PezziB,2,2,2);
	set_translate(PezziB,-21.3,36.2,-4.2);
	set_z_rotate(PezziN,3.15,0);
	set_scale(PezziN,2,2,2);
	set_translate(PezziN,-19,23.5,-4.2);


	pedoneb1 = read_nurbs("pedone.db");
	set_bump_texture(pedoneb1, white, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(pedoneb1,2,2,2);
	set_translate(pedoneb1,-19.5,32.7,-4.2);

	pedoneb2 = create_copy(pedoneb1,"pedoneb2");
	set_translate(pedoneb2,2,0,0);

	pedoneb3 = create_copy(pedoneb2,"pedoneb3");
	set_translate(pedoneb3,1.8,1.8,0);

	pedoneb4 = create_copy(pedoneb1,"pedoneb4");
	set_translate(pedoneb4,-3.8,1.8,0);

	pedoneb5 = create_copy(pedoneb4,"pedoneb5");
	set_translate(pedoneb5,-1.7,-1.8,0);

	pedoneb6 = create_copy(pedoneb5,"pedoneb5");
	set_translate(pedoneb6,-8,-1.8,-1.15);

	pedoneb7 = create_copy(pedoneb6,"pedoneb5");
	set_translate(pedoneb7,0,-2.5,0);

	alfiereb = read_obj("alfiere.obj","alfiereb");
	set_bump_texture(alfiereb, white, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(alfiereb,2,2,2);
	set_translate(alfiereb,-30.5,32.7,-4.2);

	torreb = read_nurbs("torre1.db");
	set_bump_texture(torreb, white, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(torreb,2,2,2);
	set_translate(torreb,-32.3,36.1,-4.2);

	cavallob = read_obj("cavallo.obj","cavallob");
	set_bump_texture(cavallob, white, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(cavallob,16,16,16);
	set_translate(cavallob,9,37,-10);	
	set_z_rotate(cavallob,90,0);


	pedonen1 = read_nurbs("pedone.db");
	set_bump_texture(pedonen1, black, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_z_rotate(pedonen1,3.15,0);
	set_scale(pedonen1,2,2,2);
	set_translate(pedonen1,-21,27,-4.2);

	pedonen2 = create_copy(pedonen1,"pedoneb2");
	set_translate(pedonen2,-1.8,-1.8,0);

	pedonen3 = create_copy(pedonen2,"pedoneb2");
	set_translate(pedonen3,-1.8,0,0);

	pedonen4 = create_copy(pedonen1,"pedoneb2");
	set_translate(pedonen4,3.8,-1.8,0);

	pedonen5 = create_copy(pedonen4,"pedoneb2");
	set_translate(pedonen5,3.7,-1.7,0);

	pedonen6 = create_copy(pedonen5,"pedoneb2");
	set_translate(pedonen6,7,0,-1.15);

	pedonen7 = create_copy(pedonen6,"pedoneb2");
	set_translate(pedonen7,1.7,-1.7,0);

	alfieren = read_obj("alfiere.obj","alfiere_nero");
	//set_bump_texture(alfieren, black, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_z_rotate(alfieren,3.15,0);
	set_scale(alfieren,2,2,2);
	set_translate(alfieren,-11.7,27,-4.2);

	torren = read_nurbs("torre1.db");
	//set_bump_texture(torren, black, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_z_rotate(torren,3.15,0);
	set_scale(torren,2,2,2);
	set_translate(torren,-9.8,27.1,-4.2);

	cavallon = read_obj("cavallo.obj","cavallo_nero");
	set_projection_texture(cavallon, black, tex_scacchi, 2,1,0.4,0.5);
	//set_bump_texture(cavallon, black, tex_scacchi, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(cavallon,16,16,16);
	set_z_rotate(cavallon,-1,0);
	set_translate(cavallon,-27,33,-10);	

	scudo1 = read_obj("scudo.obj","scudo1");
	set_scale(scudo1,2,2,2);
	set_projection_texture(scudo1, metal, tex_scudo,1,1,0.4,0.5);
	set_scale(scudo1,0.5,0.5,0.5);
	 scudo2 = create_copy(scudo1,"scudo2");
	set_scale(scudo1,33,33,35);
	set_z_rotate(scudo1,18.1,0);
	set_translate(scudo1,-115.5,-60,60);
	 set_scale(scudo2,33,33,35);
	 set_z_rotate(scudo2,7.05,0);
	 set_translate(scudo2,80,-110,60);

	calice1 = read_nurbs("calice.db");
	set_scale(calice1,5,5,5);
	set_translate(calice1,-29,43,-2);
	set_attribute(calice1,glass);

	calice2 = create_copy(calice1,"calice2");
	set_translate(calice2,8,-28,0);
	set_attribute(calice2,glass);

	lama = read_nurbs("lama.db");
	set_projection_texture(lama,metal, tex_steel,2,1,0.4,0.5);
	set_scale(lama,12,12,12);
	set_x_rotate(lama,9.6,0);
	set_z_rotate(lama,4.9,0);
	set_translate(lama,7,-10,22);

	pomo = read_nurbs("pomo.db");
	set_scale(pomo,12,12,12);
	set_x_rotate(pomo,9.6,0);
	set_z_rotate(pomo,4.9,0);
	set_translate(pomo,7,-10,22);
	set_attribute(pomo,metal);

	guardia = read_nurbs("guardia.db");
	//set_bump_texture(guardia, metal, tex_steel, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(guardia,12,12,12);
	set_x_rotate(guardia,9.6,0);
	set_z_rotate(guardia,4.9,0);
	set_translate(guardia,7,-10,22);
	set_attribute(guardia, metal);

	impugnatura = read_nurbs("impugnatura.db");
	//set_bump_texture(impugnatura, material1, tex_bump, 0, 0.09,0, 0.09, 1,0.6, 0.8);
	set_scale(impugnatura,12,12,12);
	set_x_rotate(impugnatura,9.6,0);
	set_z_rotate(impugnatura,4.9,0);
	set_translate(impugnatura,7,-10,22);
	set_attribute(impugnatura, material1);

	testa_cavallo = read_obj("cavallog.obj","testa_cavallo");
// 	set_projection_texture(testa_cavallo, black, tex_scacchi, 2,1,0.4,0.5);
	set_scale(testa_cavallo,8,8,8);
	set_z_rotate(testa_cavallo,-2.2,0);
	set_translate(testa_cavallo,-79,-80,20);
	set_attribute(testa_cavallo,metal);

	piedistallo = read_nurbs("piedistallo.db");
	set_projection_texture(piedistallo,material1,tex_granito,1,1,0.4,0.5);
 	set_scale(piedistallo,12,12,12);
	set_translate(piedistallo,-79,-80,-9.65);
	set_attribute(piedistallo, material1);

	scene = create_list(parete1, "scene");
	scene = insert_in_list(scene,parete2);
	scene = insert_in_list(scene,parete3);
	scene = insert_in_list(scene,parete4);
	scene = insert_in_list(scene,parete5);
	scene = insert_in_list(scene,tappeto);
	scene = insert_in_list(scene,pianotavolo);
	scene = insert_in_list(scene,gambatavolo);
	scene = insert_in_list(scene,sedia1);
	scene = insert_in_list(scene,sedia2);
	scene = insert_in_list(scene,colonna);
	scene = insert_in_list(scene,bordoscacchiera);
	scene = insert_in_list(scene,pianoscacchiera);
	scene = insert_in_list(scene,fiamma);
	scene = insert_in_list(scene,candela);
	scene = insert_in_list(scene,supcandela);
	scene = insert_in_list(scene,PezziB);
	scene = insert_in_list(scene,pedoneb1);
	scene = insert_in_list(scene,pedoneb2);
	scene = insert_in_list(scene,pedoneb3);
	scene = insert_in_list(scene,pedoneb4);
	scene = insert_in_list(scene,pedoneb5);
	scene = insert_in_list(scene,pedoneb6);
	scene = insert_in_list(scene,pedoneb7);
	scene = insert_in_list(scene,alfiereb);
	scene = insert_in_list(scene,torreb);
	scene = insert_in_list(scene,cavallob);
	scene = insert_in_list(scene,PezziN);
	scene = insert_in_list(scene,pedonen1);
	scene = insert_in_list(scene,pedonen2);
	scene = insert_in_list(scene,pedonen3);
	scene = insert_in_list(scene,pedonen4);
	scene = insert_in_list(scene,pedonen5);
	scene = insert_in_list(scene,pedonen6);
	scene = insert_in_list(scene,pedonen7);
	scene = insert_in_list(scene,alfieren);
	scene = insert_in_list(scene,torren);
	scene = insert_in_list(scene,cavallon);
	scene = insert_in_list(scene,scudo1);
	scene = insert_in_list(scene,scudo2);
	scene = insert_in_list(scene,calice1);
	scene = insert_in_list(scene,calice2);
	scene = insert_in_list(scene,lama);
	scene = insert_in_list(scene,pomo);
	scene = insert_in_list(scene,guardia);
	scene = insert_in_list(scene,impugnatura);
	scene = insert_in_list(scene,testa_cavallo);
	scene = insert_in_list(scene,piedistallo);
	save_scene("chess.md","scene_chess",scene);
	
	return(0);
}
